# coding: utf-8

"""
    (v2.0) Dynamics 365 Business Central

    (v2.0) Business Central Standard APIs

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from pybusinesscentral.model.account import Account
from pybusinesscentral.model.customer_payment import CustomerPayment
from typing import Optional, Set
from typing_extensions import Self

class CustomerPaymentJournal(BaseModel):
    """
    CustomerPaymentJournal
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="(v1.0) The id property for the Dynamics 365 Business Central customerPaymentJournal entity")
    code: Optional[Annotated[str, Field(strict=True, max_length=10)]] = Field(default=None, description="(v1.0) The code property for the Dynamics 365 Business Central customerPaymentJournal entity")
    display_name: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="(v1.0) The displayName property for the Dynamics 365 Business Central customerPaymentJournal entity", alias="displayName")
    last_modified_date_time: Optional[datetime] = Field(default=None, description="(v1.0) The lastModifiedDateTime property for the Dynamics 365 Business Central customerPaymentJournal entity", alias="lastModifiedDateTime")
    balancing_account_id: Optional[StrictStr] = Field(default=None, description="(v1.0) The balancingAccountId property for the Dynamics 365 Business Central customerPaymentJournal entity", alias="balancingAccountId")
    balancing_account_number: Optional[Annotated[str, Field(strict=True, max_length=20)]] = Field(default=None, description="(v1.0) The balancingAccountNumber property for the Dynamics 365 Business Central customerPaymentJournal entity", alias="balancingAccountNumber")
    customer_payments: Optional[List[CustomerPayment]] = Field(default=None, alias="customerPayments")
    account: Optional[Account] = None
    __properties: ClassVar[List[str]] = ["id", "code", "displayName", "lastModifiedDateTime", "balancingAccountId", "balancingAccountNumber", "customerPayments", "account"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CustomerPaymentJournal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in customer_payments (list)
        _items = []
        if self.customer_payments:
            for _item_customer_payments in self.customer_payments:
                if _item_customer_payments:
                    _items.append(_item_customer_payments.to_dict())
            _dict['customerPayments'] = _items
        # override the default output from pydantic by calling `to_dict()` of account
        if self.account:
            _dict['account'] = self.account.to_dict()
        # set to None if display_name (nullable) is None
        # and model_fields_set contains the field
        if self.display_name is None and "display_name" in self.model_fields_set:
            _dict['displayName'] = None

        # set to None if last_modified_date_time (nullable) is None
        # and model_fields_set contains the field
        if self.last_modified_date_time is None and "last_modified_date_time" in self.model_fields_set:
            _dict['lastModifiedDateTime'] = None

        # set to None if balancing_account_id (nullable) is None
        # and model_fields_set contains the field
        if self.balancing_account_id is None and "balancing_account_id" in self.model_fields_set:
            _dict['balancingAccountId'] = None

        # set to None if balancing_account_number (nullable) is None
        # and model_fields_set contains the field
        if self.balancing_account_number is None and "balancing_account_number" in self.model_fields_set:
            _dict['balancingAccountNumber'] = None

        # set to None if customer_payments (nullable) is None
        # and model_fields_set contains the field
        if self.customer_payments is None and "customer_payments" in self.model_fields_set:
            _dict['customerPayments'] = None

        # set to None if account (nullable) is None
        # and model_fields_set contains the field
        if self.account is None and "account" in self.model_fields_set:
            _dict['account'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CustomerPaymentJournal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "code": obj.get("code"),
            "displayName": obj.get("displayName"),
            "lastModifiedDateTime": obj.get("lastModifiedDateTime"),
            "balancingAccountId": obj.get("balancingAccountId"),
            "balancingAccountNumber": obj.get("balancingAccountNumber"),
            "customerPayments": [CustomerPayment.from_dict(_item) for _item in obj["customerPayments"]] if obj.get("customerPayments") is not None else None,
            "account": Account.from_dict(obj["account"]) if obj.get("account") is not None else None
        })
        return _obj


