# coding: utf-8

"""
    (v2.0) Dynamics 365 Business Central

    (v2.0) Business Central Standard APIs

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class PaymentTerm(BaseModel):
    """
    PaymentTerm
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="(v1.0) The id property for the Dynamics 365 Business Central paymentTerm entity")
    code: Optional[Annotated[str, Field(strict=True, max_length=10)]] = Field(default=None, description="(v1.0) The code property for the Dynamics 365 Business Central paymentTerm entity")
    display_name: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="(v1.0) The displayName property for the Dynamics 365 Business Central paymentTerm entity", alias="displayName")
    due_date_calculation: Optional[StrictStr] = Field(default=None, description="(v1.0) The dueDateCalculation property for the Dynamics 365 Business Central paymentTerm entity", alias="dueDateCalculation")
    discount_date_calculation: Optional[StrictStr] = Field(default=None, description="(v1.0) The discountDateCalculation property for the Dynamics 365 Business Central paymentTerm entity", alias="discountDateCalculation")
    discount_percent: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="(v1.0) The discountPercent property for the Dynamics 365 Business Central paymentTerm entity", alias="discountPercent")
    calculate_discount_on_credit_memos: Optional[StrictBool] = Field(default=None, description="(v1.0) The calculateDiscountOnCreditMemos property for the Dynamics 365 Business Central paymentTerm entity", alias="calculateDiscountOnCreditMemos")
    last_modified_date_time: Optional[datetime] = Field(default=None, description="(v1.0) The lastModifiedDateTime property for the Dynamics 365 Business Central paymentTerm entity", alias="lastModifiedDateTime")
    __properties: ClassVar[List[str]] = ["id", "code", "displayName", "dueDateCalculation", "discountDateCalculation", "discountPercent", "calculateDiscountOnCreditMemos", "lastModifiedDateTime"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PaymentTerm from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if display_name (nullable) is None
        # and model_fields_set contains the field
        if self.display_name is None and "display_name" in self.model_fields_set:
            _dict['displayName'] = None

        # set to None if due_date_calculation (nullable) is None
        # and model_fields_set contains the field
        if self.due_date_calculation is None and "due_date_calculation" in self.model_fields_set:
            _dict['dueDateCalculation'] = None

        # set to None if discount_date_calculation (nullable) is None
        # and model_fields_set contains the field
        if self.discount_date_calculation is None and "discount_date_calculation" in self.model_fields_set:
            _dict['discountDateCalculation'] = None

        # set to None if discount_percent (nullable) is None
        # and model_fields_set contains the field
        if self.discount_percent is None and "discount_percent" in self.model_fields_set:
            _dict['discountPercent'] = None

        # set to None if calculate_discount_on_credit_memos (nullable) is None
        # and model_fields_set contains the field
        if self.calculate_discount_on_credit_memos is None and "calculate_discount_on_credit_memos" in self.model_fields_set:
            _dict['calculateDiscountOnCreditMemos'] = None

        # set to None if last_modified_date_time (nullable) is None
        # and model_fields_set contains the field
        if self.last_modified_date_time is None and "last_modified_date_time" in self.model_fields_set:
            _dict['lastModifiedDateTime'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PaymentTerm from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "code": obj.get("code"),
            "displayName": obj.get("displayName"),
            "dueDateCalculation": obj.get("dueDateCalculation"),
            "discountDateCalculation": obj.get("discountDateCalculation"),
            "discountPercent": obj.get("discountPercent"),
            "calculateDiscountOnCreditMemos": obj.get("calculateDiscountOnCreditMemos"),
            "lastModifiedDateTime": obj.get("lastModifiedDateTime")
        })
        return _obj


