# coding: utf-8

"""
    (v2.0) Dynamics 365 Business Central

    (v2.0) Business Central Standard APIs

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class PostDimensionSetLineRequest(BaseModel):
    """
    PostDimensionSetLineRequest
    """ # noqa: E501
    parent_id: Optional[StrictStr] = Field(default=None, description="(v1.0) The parentId property for the Dynamics 365 Business Central dimensionLine entity", alias="parentId")
    id: Optional[StrictStr] = Field(default=None, description="(v1.0) The id property for the Dynamics 365 Business Central dimensionLine entity")
    code: Optional[Annotated[str, Field(strict=True, max_length=20)]] = Field(default=None, description="(v1.0) The code property for the Dynamics 365 Business Central dimensionLine entity")
    display_name: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(default=None, description="(v1.0) The displayName property for the Dynamics 365 Business Central dimensionLine entity", alias="displayName")
    value_id: Optional[StrictStr] = Field(default=None, description="(v1.0) The valueId property for the Dynamics 365 Business Central dimensionLine entity", alias="valueId")
    value_code: Optional[StrictStr] = Field(default=None, description="(v1.0) The valueCode property for the Dynamics 365 Business Central dimensionLine entity", alias="valueCode")
    value_display_name: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="(v1.0) The valueDisplayName property for the Dynamics 365 Business Central dimensionLine entity", alias="valueDisplayName")
    __properties: ClassVar[List[str]] = ["parentId", "id", "code", "displayName", "valueId", "valueCode", "valueDisplayName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostDimensionSetLineRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if code (nullable) is None
        # and model_fields_set contains the field
        if self.code is None and "code" in self.model_fields_set:
            _dict['code'] = None

        # set to None if display_name (nullable) is None
        # and model_fields_set contains the field
        if self.display_name is None and "display_name" in self.model_fields_set:
            _dict['displayName'] = None

        # set to None if value_id (nullable) is None
        # and model_fields_set contains the field
        if self.value_id is None and "value_id" in self.model_fields_set:
            _dict['valueId'] = None

        # set to None if value_code (nullable) is None
        # and model_fields_set contains the field
        if self.value_code is None and "value_code" in self.model_fields_set:
            _dict['valueCode'] = None

        # set to None if value_display_name (nullable) is None
        # and model_fields_set contains the field
        if self.value_display_name is None and "value_display_name" in self.model_fields_set:
            _dict['valueDisplayName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostDimensionSetLineRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "parentId": obj.get("parentId"),
            "id": obj.get("id"),
            "code": obj.get("code"),
            "displayName": obj.get("displayName"),
            "valueId": obj.get("valueId"),
            "valueCode": obj.get("valueCode"),
            "valueDisplayName": obj.get("valueDisplayName")
        })
        return _obj


