# coding: utf-8

"""
    (v2.0) Dynamics 365 Business Central

    (v2.0) Business Central Standard APIs

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class RetainedEarningsStatement(BaseModel):
    """
    RetainedEarningsStatement
    """ # noqa: E501
    line_number: Optional[StrictInt] = Field(default=None, description="(v1.0) The lineNumber property for the Dynamics 365 Business Central retainedEarningsStatement entity", alias="lineNumber")
    display: Optional[Annotated[str, Field(strict=True, max_length=250)]] = Field(default=None, description="(v1.0) The display property for the Dynamics 365 Business Central retainedEarningsStatement entity")
    net_change: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="(v1.0) The netChange property for the Dynamics 365 Business Central retainedEarningsStatement entity", alias="netChange")
    line_type: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(default=None, description="(v1.0) The lineType property for the Dynamics 365 Business Central retainedEarningsStatement entity", alias="lineType")
    indentation: Optional[StrictInt] = Field(default=None, description="(v1.0) The indentation property for the Dynamics 365 Business Central retainedEarningsStatement entity")
    date_filter: Optional[datetime] = Field(default=None, description="(v1.0) The dateFilter property for the Dynamics 365 Business Central retainedEarningsStatement entity", alias="dateFilter")
    __properties: ClassVar[List[str]] = ["lineNumber", "display", "netChange", "lineType", "indentation", "dateFilter"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RetainedEarningsStatement from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if display (nullable) is None
        # and model_fields_set contains the field
        if self.display is None and "display" in self.model_fields_set:
            _dict['display'] = None

        # set to None if net_change (nullable) is None
        # and model_fields_set contains the field
        if self.net_change is None and "net_change" in self.model_fields_set:
            _dict['netChange'] = None

        # set to None if line_type (nullable) is None
        # and model_fields_set contains the field
        if self.line_type is None and "line_type" in self.model_fields_set:
            _dict['lineType'] = None

        # set to None if indentation (nullable) is None
        # and model_fields_set contains the field
        if self.indentation is None and "indentation" in self.model_fields_set:
            _dict['indentation'] = None

        # set to None if date_filter (nullable) is None
        # and model_fields_set contains the field
        if self.date_filter is None and "date_filter" in self.model_fields_set:
            _dict['dateFilter'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RetainedEarningsStatement from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "lineNumber": obj.get("lineNumber"),
            "display": obj.get("display"),
            "netChange": obj.get("netChange"),
            "lineType": obj.get("lineType"),
            "indentation": obj.get("indentation"),
            "dateFilter": obj.get("dateFilter")
        })
        return _obj


